<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-primary self-end"
        v-text="'Redações'"
      />
    </div>

    <table-view
      class="col-12"
      sort-by="id"
      :columns="columns"
      :table-data="tableData"
      :filter-menu="filterMenu"
      @status="setStatus"
    />
  </q-page>
</template>

<script>
import TableView from '../../components/composing/table-view'
import { formatToDate } from 'brazilian-values'

export default {
  name: 'PageCompositions',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Compositions',
          params: {
            filter: {
              where: {
                status: {
                  neq: this.status
                }
              },
              include: [
                {
                  relation: 'topic',
                  scope: {
                    fields: ['name']
                  }
                },
                {
                  relation: 'usuarios',
                  scope: {
                    fields: ['name']
                  }
                }
              ]
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      status: 'Corrigido',
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'topic', field: 'topic', label: 'Tema', align: 'left', sortable: true, format: (val, row) => val ? val.name : row.topicId },
        { name: 'title', field: 'title', label: 'Título', align: 'left', sortable: true },
        { name: 'createdAt', field: 'createdAt', label: 'Data de Envio', align: 'left', sortable: true, format: (val) => this.formatDate(val) },
        { name: 'usuarios', field: 'usuarios', label: 'Aluno', align: 'left', sortable: true, format: (val, row) => val ? val.name : row.usuarioId },
        { name: 'status', field: 'status', label: 'Status', align: 'left', sortable: true },
        { name: 'action', field: 'action', label: 'Avaliar', align: 'center' }
      ],
      filterMenu: [
        { key: 'status', status: null, name: 'Todas' },
        { key: 'status', status: 'Corrigido', name: 'Enviadas' },
        { key: 'status', status: 'Enviado', name: 'Corrigidas' }
      ]
    }
  },
  mounted () {
    this.$emit('topic', null)
  },
  methods: {
    formatDate (value) {
      try {
        return formatToDate(new Date(value))
      } catch (e) {
        return value
      }
    },
    setStatus (status) {
      this.status = status
      this.asyncReload('tableData')
    }
  }
}
</script>
